DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Splitter

You can use our JavaScript Splitter UI widgets to create resizable panes within your DevExtreme-powered web app/page.

To get started with DevExtreme JavaScript Splitter, refer to the following tutorial for step-by-step instructions: Getting Started with JavaScript Splitter.

DevExtreme Accessibility Compliance
DevExtreme component libraries meet a variety of WCAG and Section 508 compliance standards. To assess this demo's accessibility level, click the Run AXE® Validation button to launch the AXE® web accessibility evaluation tool.
All trademarks or registered trademarks are property of their respective owners. AXE® Terms of Use
The overall accessibility level of your application depends on the Splitter features used.
Backend API
$(() => { const createElementWithClass = function (text, className) { return $('<div>').text(text).addClass(className); }; const getStateText = function (data) { if (data.resizable !== false && !data.collapsible) { return 'Resizable only'; } const resizableText = data.resizable ? 'Resizable' : 'Non-resizable'; const collapsibleText = data.collapsible ? 'collapsible' : 'non-collapsible'; return `${resizableText} and ${collapsibleText}`; }; const paneContentTemplate = function (data, element, paneName) { $(element).attr({ tabIndex: 0 }); const $content = createElementWithClass('', 'pane-content'); $content.append(createElementWithClass(paneName, 'pane-title')); $content.append(createElementWithClass(getStateText(data), 'pane-state')); const dimensionOptions = new Set(['size', 'minSize', 'maxSize', 'collapsedSize']); Object.entries(data) .filter(([key]) => dimensionOptions.has(key)) .forEach(([key, value]) => { $content.append(createElementWithClass(`${key}: ${value}`, 'pane-option')); }); return $content; }; $('#splitter').dxSplitter({ items: [ { resizable: true, size: '140px', minSize: '70px', template(data, index, element) { return paneContentTemplate(data, element, 'Left Pane'); }, }, { splitter: { orientation: 'vertical', items: [ { resizable: true, collapsible: true, maxSize: '75%', collapsedSize: '8%', template(data, index, element) { return paneContentTemplate(data, element, 'Central Pane'); }, }, { collapsible: true, splitter: { orientation: 'horizontal', items: [ { resizable: true, collapsible: true, size: '30%', minSize: '5%', template(data, index, element) { return paneContentTemplate(data, element, 'Nested Left Pane'); }, }, { collapsible: false, template(data, index, element) { return paneContentTemplate(data, element, 'Nested Central Pane'); }, }, { resizable: true, collapsible: true, size: '30%', minSize: '5%', template(data, index, element) { return paneContentTemplate(data, element, 'Nested Right Pane'); }, }, ], }, }, ], }, }, { size: '140px', resizable: false, collapsible: false, template(data, index, element) { return paneContentTemplate(data, element, 'Right Pane'); }, }, ], }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="renderPaneContentFile.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="splitter"></div> </div> </body> </html>
.demo-container { height: 500px; } #splitter { border: 1px solid var(--dx-color-border); border-radius: 8px; overflow: hidden; } .pane-content { padding: 12px; } .pane-title { font-weight: 600; margin-bottom: 2px; } .pane-state { font-size: var(--dx-font-size-xs); margin-bottom: 4px; } .pane-option { color: var(--dx-texteditor-color-label); font-size: 10px; } #splitter > .dx-splitter-item:first-child > .dx-splitter-item-content:focus { border-start-start-radius: 8px; border-end-start-radius: 8px; } #splitter > .dx-splitter-item:last-child > .dx-splitter-item-content:focus { border-end-end-radius: 8px; border-start-end-radius: 8px; } .dx-splitter-item-content:focus { outline: none; box-shadow: inset 0 0 0 1px var(--dx-color-primary); }

To specify individual splitter panes, set the items or dataSource property. Use dataSource if data is remote or should be processed. If you specify multiple panes, they will appear one after another with splitters between them.

The following base options are available for a pane:

  • resizable (default: true)
    If true, a handle appears at the side of the pane. Drag the handle to adjust pane size.

  • collapsible (default: false)
    If true, an arrow appears on the handle. Click the arrow to close the pane.

  • collapsed (default: false)
    Specifies whether the pane is initially collapsed.

To configure the layout of the JavaScript Splitter component, you can specify its orientation as 'vertical' or 'horizontal' (default). All JavaScript Splitter "size" properties depend on the orientation. If it is 'horizontal', "size" is the width. Otherwise, it is height. The following pane "size" properties can be specified:

  • size
    Initial pane width/height.

  • minSize
    Minimum width/height for a resizable pane.

  • maxSize
    Maximum width/height for a resizable pane.

  • collapsedSize
    The width/height of a collapsible pane when collapsed.

You can also place one JavaScript Splitter inside another to create nested layouts. To do so, use the pane's splitter property.

JavaScript Splitter panes can include different content types, from simple HTML markup to components. You can declare HTML markup inside the item tag or use the following properties to populate panes with content:

  • itemTemplate
    Specifies a custom template for all panes.

  • template
    Specifies a custom template for an individual pane.

<template>
<DxSplitter
id="splitter"
>
<DxItem
:resizable="true"
size="140px"
min-size="70px"
text="Left Pane"
template="paneContent"
/>
<DxItem>
<DxSplitter
orientation="vertical"
>
<DxItem
:resizable="true"
:collapsible="true"
max-size="75%"
collapsed-size="8%"
text="Central Pane"
template="paneContent"
/>
<DxItem :collapsible="true">
<DxSplitter>
<DxItem
:resizable="true"
:collapsible="true"
size="30%"
min-size="5%"
text="Nested Left Pane"
template="paneContent"
/>
<DxItem
:resizable="true"
text="Nested Central Pane"
template="paneContent"
/>
<DxItem
:resizable="true"
:collapsible="true"
size="30%"
min-size="5%"
text="Nested Right Pane"
template="paneContent"
/>
<template #paneContent="{ data }">
<PaneContent
:data="data"
/>
</template>
</DxSplitter>
</DxItem>
<template #paneContent="{ data }">
<PaneContent
:data="data"
/>
</template>
</DxSplitter>
</DxItem>
<DxItem
:resizable="false"
:collapsible="false"
size="140px"
text="Right Pane"
template="paneContent"
/>
<template #paneContent="{ data }">
<PaneContent
:data="data"
/>
</template>
</DxSplitter>
</template>
<script setup lang="ts">
import { DxSplitter, DxItem } from 'devextreme-vue/splitter';
import PaneContent from './PaneContent.vue';
</script>
<style scoped>
.demo-container {
height: 500px;
}
#app {
height: 100%;
}
#splitter {
border: 1px solid var(--dx-color-border);
border-radius: 8px;
overflow: hidden;
}
#splitter > .dx-splitter-item:first-child > .dx-splitter-item-content:focus {
border-start-start-radius: 8px;
border-end-start-radius: 8px;
}
#splitter > .dx-splitter-item:last-child > .dx-splitter-item-content:focus {
border-end-end-radius: 8px;
border-start-end-radius: 8px;
}
.dx-splitter-item-content:focus {
outline: none;
box-shadow: inset 0 0 0 1px var(--dx-color-primary);
}
</style>
<template>
<div tabindex="0">
<div
class="pane-content"
>
<div class="pane-title">
{{ data.text }}
</div>
<div class="pane-state">
{{ getStateText() }}
</div>
<div
class="pane-option"
v-for="(value, key) in filteredData"
:key="key"
>
{{ `${key}: ${value}` }}
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { computed } from 'vue';
const props = defineProps<{
data: Record<string, any>
}>();
const { data } = props;
const dimensionOptions = new Set(['size', 'minSize', 'maxSize', 'collapsedSize']);
const getStateText = function () {
if (data.resizable !== false && !data.collapsible) {
return 'Resizable only';
}
const resizableText = data.resizable ? 'Resizable' : 'Non-resizable';
const collapsibleText = data.collapsible ? 'collapsible' : 'non-collapsible';
return `${resizableText} and ${collapsibleText}`;
};
const filteredData = computed(() => Object.fromEntries(
Object.entries(data)
.filter(([key]) => dimensionOptions.has(key)),
));
</script>
<style scoped>
.pane-content {
padding: 12px;
}
.pane-title {
font-weight: 600;
margin-bottom: 2px;
}
.pane-state {
font-size: var(--dx-font-size-xs);
margin-bottom: 4px;
}
.pane-option {
color: var(--dx-texteditor-color-label);
font-size: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import themes from 'devextreme/ui/themes';
import App from './App.vue';
themes.initialized(() => createApp(App).mount('#app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-splitter id="splitter">
<dxi-splitter-item
[resizable]="true"
minSize="70px"
size="140px"
template="Left Pane"
></dxi-splitter-item>
<dxi-splitter-item [resizable]="true">
<dx-splitter orientation="vertical">
<dxi-splitter-item
[resizable]="true"
[collapsible]="true"
collapsedSize="8%"
maxSize="75%"
template="Central Pane"
></dxi-splitter-item>
<dxi-splitter-item [resizable]="true" [collapsible]="true">
<dx-splitter>
<dxi-splitter-item
[resizable]="true"
[collapsible]="true"
minSize="5%"
size="30%"
template="Nested Left Pane"
></dxi-splitter-item>
<dxi-splitter-item
[resizable]="true"
template="Nested Central Pane"
></dxi-splitter-item>
<dxi-splitter-item
[resizable]="true"
[collapsible]="true"
minSize="5%"
size="30%"
template="Nested Right Pane"
></dxi-splitter-item>
@for (pane of paneContentTemplates; track pane.name) {
<ng-container>
<div *dxTemplate="let data of pane.name" tabindex="0">
<ng-template
[ngTemplateOutlet]="customPaneTemplate"
[ngTemplateOutletContext]="{ data: data, title: pane.name }"
>
</ng-template>
</div>
</ng-container>
}
</dx-splitter>
</dxi-splitter-item>
@for (pane of paneContentTemplates; track pane.name) {
<ng-container>
<div *dxTemplate="let data of pane.name" tabindex="0">
<ng-template
[ngTemplateOutlet]="customPaneTemplate"
[ngTemplateOutletContext]="{ data: data, title: pane.name }"
>
</ng-template>
</div>
</ng-container>
}
</dx-splitter>
</dxi-splitter-item>
<dxi-splitter-item
[resizable]="false"
[collapsible]="false"
size="140px"
template="Right Pane"
></dxi-splitter-item>
@for (pane of paneContentTemplates; track pane.name) {
<ng-container>
<div *dxTemplate="let data of pane.name" tabindex="0">
<ng-template
[ngTemplateOutlet]="customPaneTemplate"
[ngTemplateOutletContext]="{ data: data, title: pane.name }"
>
</ng-template>
</div>
</ng-container>
}
</dx-splitter>
<ng-template #customPaneTemplate let-data="data" let-title="title">
<div class="pane-content">
<div class="pane-title">{{ title }}</div>
<div class="pane-state">{{ getPaneState(data) }}</div>
@for (item of filterDimensionOptions(data); track item.key) {
<ng-container>
<div class="pane-option">{{ item.key }}: {{ item.value }}</div>
</ng-container>
}
</div>
</ng-template>
import { bootstrapApplication } from '@angular/platform-browser';
import { ChangeDetectionStrategy, Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { NgTemplateOutlet } from '@angular/common';
import { DxSplitterModule } from 'devextreme-angular';
if (!document.location.host.includes('localhost')) {
enableProdMode();
}
interface PaneContentTemplate {
name: string;
data?: any;
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
changeDetection: ChangeDetectionStrategy.Eager,
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
changeDetection: ChangeDetectionStrategy.OnPush,
imports: [
DxSplitterModule,
NgTemplateOutlet,
],
})
export class AppComponent {
dimensionOptions = new Set(['size', 'minSize', 'maxSize', 'collapsedSize']);
paneContentTemplates: PaneContentTemplate[] = [
{ name: 'Left Pane' },
{ name: 'Central Pane' },
{ name: 'Right Pane' },
{ name: 'Nested Left Pane' },
{ name: 'Nested Central Pane' },
{ name: 'Nested Right Pane' },
];
getPaneState(data: any): string {
if (data.resizable !== false && !data.collapsible) {
return 'Resizable only';
}
const resizableText = data.resizable ? 'Resizable' : 'Non-resizable';
const collapsibleText = data.collapsible ? 'collapsible' : 'non-collapsible';
return `${resizableText} and ${collapsibleText}`;
}
filterDimensionOptions(data: any): { key: string; value: any }[] {
return Object.entries(data)
.reverse()
.filter(([key]) => this.dimensionOptions.has(key))
.map(([key, value]) => ({ key, value }));
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .demo-container {
height: 500px;
}
::ng-deep #splitter {
border: 1px solid var(--dx-color-border);
border-radius: 8px;
overflow: hidden;
}
::ng-deep .pane-content {
padding: 12px;
}
::ng-deep .pane-title {
font-weight: 600;
margin-bottom: 2px;
}
::ng-deep .pane-state {
font-size: var(--dx-font-size-xs);
margin-bottom: 4px;
}
::ng-deep .pane-option {
color: var(--dx-texteditor-color-label);
font-size: 10px;
}
::ng-deep #splitter > .dx-splitter-item:first-child > .dx-splitter-item-content:focus {
border-start-start-radius: 8px;
border-end-start-radius: 8px;
}
::ng-deep #splitter > .dx-splitter-item:last-child > .dx-splitter-item-content:focus {
border-end-end-radius: 8px;
border-start-end-radius: 8px;
}
::ng-deep .dx-splitter-item-content:focus {
outline: none;
box-shadow: inset 0 0 0 1px var(--dx-color-primary);
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import Splitter, { Item } from 'devextreme-react/splitter';
import PaneContent from './PaneContent.tsx';
interface RenderData {
resizable?: boolean;
collapsible?: boolean;
}
const PaneContentWithTitle = (title: string, initialSize?: string) => (data: RenderData) => (<PaneContent title={title} {...data} size={initialSize} />);
const App = () => (
<>
<Splitter
id="splitter"
>
<Item
resizable={true}
size="140px"
minSize="70px"
render={PaneContentWithTitle('Left Pane', '140px')}
/>
<Item
resizable={true}
>
<Splitter
orientation="vertical"
>
<Item
resizable={true}
collapsible={true}
maxSize="75%"
collapsedSize="8%"
render={PaneContentWithTitle('Central Pane')}
/>
<Item
resizable={true}
collapsible={true}
>
<Splitter>
<Item
resizable={true}
collapsible={true}
size="30%"
minSize="5%"
render={PaneContentWithTitle('Nested Left Pane', '30%')}
/>
<Item
resizable={true}
render={PaneContentWithTitle('Nested Central Pane')}
/>
<Item
resizable={true}
collapsible={true}
size="30%"
minSize="5%"
render={PaneContentWithTitle('Nested Right Pane', '30%')}
/>
</Splitter>
</Item>
</Splitter>
</Item>
<Item
resizable={false}
collapsible={false}
size="140px"
render={PaneContentWithTitle('Right Pane', '140px')}
/>
</Splitter>
</>
);
export default App;
import React from 'react';
import Splitter, { Item } from 'devextreme-react/splitter';
import PaneContent from './PaneContent.js';
const PaneContentWithTitle = (title, initialSize) => (data) =>
(
<PaneContent
title={title}
{...data}
size={initialSize}
/>
);
const App = () => (
<>
<Splitter id="splitter">
<Item
resizable={true}
size="140px"
minSize="70px"
render={PaneContentWithTitle('Left Pane', '140px')}
/>
<Item resizable={true}>
<Splitter orientation="vertical">
<Item
resizable={true}
collapsible={true}
maxSize="75%"
collapsedSize="8%"
render={PaneContentWithTitle('Central Pane')}
/>
<Item
resizable={true}
collapsible={true}
>
<Splitter>
<Item
resizable={true}
collapsible={true}
size="30%"
minSize="5%"
render={PaneContentWithTitle('Nested Left Pane', '30%')}
/>
<Item
resizable={true}
render={PaneContentWithTitle('Nested Central Pane')}
/>
<Item
resizable={true}
collapsible={true}
size="30%"
minSize="5%"
render={PaneContentWithTitle('Nested Right Pane', '30%')}
/>
</Splitter>
</Item>
</Splitter>
</Item>
<Item
resizable={false}
collapsible={false}
size="140px"
render={PaneContentWithTitle('Right Pane', '140px')}
/>
</Splitter>
</>
);
export default App;
import React, { useRef, useEffect } from 'react';
const dimensionOptions = new Set(['size', 'minSize', 'maxSize', 'collapsedSize']);
interface PaneContentProps {
title: string;
size?: string;
resizable?: boolean;
collapsible?: boolean;
minSize?: string;
maxSize?: string;
collapsedSize?: string;
}
const getPaneState = (data: PaneContentProps): string => {
if (data.resizable !== false && !data.collapsible) {
return 'Resizable only';
}
const resizableText = data.resizable ? 'Resizable' : 'Non-resizable';
const collapsibleText = data.collapsible ? 'collapsible' : 'non-collapsible';
return `${resizableText} and ${collapsibleText}`;
};
const getFilteredDimensionOptions = (data: PaneContentProps) => Object.entries(data)
.filter(([key, value]) => dimensionOptions.has(key) && value)
.map(([key, value]) => ({ key, value }));
const PaneContent = (data: PaneContentProps) => {
const paneContentRef = useRef<HTMLDivElement>(null);
useEffect(() => {
const element = paneContentRef.current?.parentNode;
if (element instanceof HTMLElement) {
element.setAttribute('tabIndex', '0');
}
});
return (
<div ref={paneContentRef} className="pane-content">
<div className="pane-title">{data.title}</div>
<div className="pane-state">{getPaneState(data)}</div>
{getFilteredDimensionOptions(data).map((item, index) => (
<div className="pane-option" key={index}>
{item.key}: {item.value}
</div>
))}
</div>
);
};
export default PaneContent;
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.tsx';
themes.initialized(() => {
ReactDOM.render(
<App />,
document.getElementById('app'),
);
});
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React, { useRef, useEffect } from 'react';
const dimensionOptions = new Set(['size', 'minSize', 'maxSize', 'collapsedSize']);
const getPaneState = (data) => {
if (data.resizable !== false && !data.collapsible) {
return 'Resizable only';
}
const resizableText = data.resizable ? 'Resizable' : 'Non-resizable';
const collapsibleText = data.collapsible ? 'collapsible' : 'non-collapsible';
return `${resizableText} and ${collapsibleText}`;
};
const getFilteredDimensionOptions = (data) =>
Object.entries(data)
.filter(([key, value]) => dimensionOptions.has(key) && value)
.map(([key, value]) => ({ key, value }));
const PaneContent = (data) => {
const paneContentRef = useRef(null);
useEffect(() => {
const element = paneContentRef.current?.parentNode;
if (element instanceof HTMLElement) {
element.setAttribute('tabIndex', '0');
}
});
return (
<div
ref={paneContentRef}
className="pane-content"
>
<div className="pane-title">{data.title}</div>
<div className="pane-state">{getPaneState(data)}</div>
{getFilteredDimensionOptions(data).map((item, index) => (
<div
className="pane-option"
key={index}
>
{item.key}: {item.value}
</div>
))}
</div>
);
};
export default PaneContent;
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.js';
themes.initialized(() => {
ReactDOM.render(<App />, document.getElementById('app'));
});
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container {
height: 500px;
}
#app {
height: 100%;
}
#splitter {
border: 1px solid var(--dx-color-border);
border-radius: 8px;
overflow: hidden;
}
.pane-content {
padding: 12px;
}
.pane-title {
font-weight: 600;
margin-bottom: 2px;
}
.pane-state {
font-size: var(--dx-font-size-xs);
margin-bottom: 4px;
}
.pane-option {
color: var(--dx-texteditor-color-label);
font-size: 10px;
}
#splitter > .dx-splitter-item:first-child > .dx-splitter-item-content:focus {
border-start-start-radius: 8px;
border-end-start-radius: 8px;
}
#splitter > .dx-splitter-item:last-child > .dx-splitter-item-content:focus {
border-end-end-radius: 8px;
border-start-end-radius: 8px;
}
.dx-splitter-item-content:focus {
outline: none;
box-shadow: inset 0 0 0 1px var(--dx-color-primary);
}